<template>
  <div id="echart" :style="{ width: props.width, height: props.height }" ref="echartRef"></div>
</template>
<script setup lang="ts">
import * as echarts from "echarts";
import { option } from "./static/lin";
const props = defineProps({
  width: {
    type: String,
    default: "600px",
  },
  height: {
    default: "600px",
  },
  modelValue: {
    type: Object,
    default: {},
  },
});
const echartRef = ref<HTMLElement>();

const state = reactive({
  myChart: undefined as unknown as echarts.EChartsType,
});

onMounted(() => {
  init();
  applyData();
});

/**
 * 初始化
 */
const init = () => {
  state.myChart = markRaw(echarts.init(echartRef.value as HTMLElement));
};

/**
 * 渲染数据
 */
const applyData = (e?: (f: any) => void) => {
  let str = JSON.stringify(option);
  let obj = JSON.parse(str);
  if (e) {
    e(obj);
  }
  state.myChart!.setOption(obj, true);
};

defineExpose({ applyData });
</script>

<style lang="scss" scoped></style>
